/* Problem URL: https://codeforces.com/contest/1000/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vl a(n);
    cin >> a;

    ll mod = 998244353;

    vvl comb(n, vl(n));
    comb[0][0] = 1;

    nrep(i, 1, n) {
        comb[i][0] = 1;
        comb[i][i] = 1;

        nrep(k, 1, n) {
            comb[i][k] = (comb[i - 1][k] + comb[i - 1][k - 1]) % mod;
        }
    }

    vl memo(n, -1);

    function<ll(int)> dp = [&](int i) -> ll {
        if (i >= n) {
            return 1;
        }

        ll &ans = memo[i];
        if (ans != -1) {
            return ans;
        }

        ans = 0;

        if (a[i] <= 0 || a[i] + i + 1 > n) {
            return 0;
        }

        ll now = 0;

        nrep(j, i + a[i] + 1, n + 1) {
            ans += dp(j) * comb[a[i] + now][a[i]];
            ans %= mod;
            now++;
        }

        return ans;
    };

    ll ans = 0;
    rep(i, n) {
        ans += dp(i);
        ans %= mod;
    }

    cout << ans << '\n';
}
